summaryrefslogtreecommitdiff
path: root/examples/cgi
diff options
context:
space:
mode:
Diffstat (limited to 'examples/cgi')
-rwxr-xr-xexamples/cgi/cgi-bin/cowsay16
-rw-r--r--examples/cgi/main.go49
2 files changed, 65 insertions, 0 deletions
diff --git a/examples/cgi/cgi-bin/cowsay b/examples/cgi/cgi-bin/cowsay
new file mode 100755
index 0000000..e63e909
--- /dev/null
+++ b/examples/cgi/cgi-bin/cowsay
@@ -0,0 +1,16 @@
+#!/usr/bin/env sh
+
+set -euo pipefail
+
+if [ -z "$QUERY_STRING" ];
+then
+ printf "10 Enter a phrase.\r\n"
+ exit 0
+fi
+
+decodeURL() { printf "%b\n" "$(sed 's/+/ /g; s/%\([0-9a-fA-F][0-9a-fA-F]\)/\\x\1/g;')"; }
+
+printf "20 text/gemini\r\n\`\`\`\n"
+echo $QUERY_STRING | decodeURL | cowsay
+echo "\`\`\`"
+echo "\n=> $SCRIPT_NAME again"
diff --git a/examples/cgi/main.go b/examples/cgi/main.go
new file mode 100644
index 0000000..e784876
--- /dev/null
+++ b/examples/cgi/main.go
@@ -0,0 +1,49 @@
+package main
+
+import (
+ "context"
+ "log"
+ "os"
+
+ "tildegit.org/tjp/gus/contrib/cgi"
+ guslog "tildegit.org/tjp/gus/contrib/log"
+ "tildegit.org/tjp/gus/gemini"
+)
+
+func main() {
+ // GET TLS files from the environment
+ certfile, keyfile := envConfig()
+
+ // build a TLS configuration suitable for gemini
+ tlsconf, err := gemini.FileTLS(certfile, keyfile)
+ if err != nil {
+ log.Fatal(err)
+ }
+
+ // make use of a CGI request handler
+ cgiHandler := cgi.CGIHandler("/cgi-bin", "cgi-bin")
+
+ // add stdout logging to the request handler
+ handler := guslog.Requests(os.Stdout, nil)(cgiHandler)
+
+ // run the server
+ server, err := gemini.NewServer(context.Background(), tlsconf, "tcp4", ":1965", handler)
+ if err != nil {
+ log.Fatal(err)
+ }
+ server.Serve()
+}
+
+func envConfig() (string, string) {
+ certfile, ok := os.LookupEnv("SERVER_CERTIFICATE")
+ if !ok {
+ log.Fatal("missing SERVER_CERTIFICATE environment variable")
+ }
+
+ keyfile, ok := os.LookupEnv("SERVER_PRIVATEKEY")
+ if !ok {
+ log.Fatal("missing SERVER_PRIVATEKEY environment variable")
+ }
+
+ return certfile, keyfile
+}